Content render modes in EJ2 JavaScript Tab control

26 Dec 202423 minutes to read

Tabs support rendering content based on different scenarios. The content of the tabs can be rendered in three different ways, as outlined below.

On Demand rendering or lazy loading

This mode is the default, where only the content of the currently selected tab is initially loaded and available in the DOM, with subsequent tab content rendered upon selection. Once a tab’s content is loaded, it remains in the DOM. This ensures that the state of the tabs, such as scroller positions, form values, etc., is preserved.

In the following code example, the Calendar and Scheduler are rendered in the first and second tabs, respectively. Initially, the Scheduler is not available, but it will be rendered once the second tab is selected. Both the Calendar and Scheduler are maintained in the DOM.

ej.base.enableRipple(true);
var tabObj = new ej.navigations.Tab({
    items: [
        {
            header: { text: 'Calendar' },
            content: '#Calendar'
        },
        {
            header: { text: 'Schedule' },
            content: '#Schedule',
        },
    ]

});
tabObj.appendTo('#element');

var calendar = new ej.calendars.Calendar();
calendar.appendTo('#Calendar');

var schedule = new ej.schedule.Schedule({
    width: '100%',
    height: '450px'
});
schedule.appendTo('#Schedule');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 Tab</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Tab">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/material.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div id="Calendar" style="display:none">
        </div>          
        <div id="Schedule" style="display:none">
        </div>
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Dynamic rendering

This mode can be applied to Tabs by setting the loadOn property to Dynamic. In this mode, only the content of the currently selected tab is loaded and available in the DOM initially. When a different tab is selected, its content replaces the current content. Since this mode ensures the DOM maintains only the content of the active tab, page loading performance is improved. However, the Tabs do not retain their state, as each time a tab is selected, it loads its content again.

In the following code example, there are two tabs. The first tab contains a login page, and the second tab contains a Grid component. The Grid component in the second tab will only be rendered in the DOM after the login is completed. Upon successful login, the second tab will replace the first tab in the DOM.

ej.base.enableRipple(true);
var tabObj = new ej.navigations.Tab({
    items: [
        {
            header: { 'text': 'Login' },
            content: '.login-form',
            disabled: false
        },
        {
            header: { 'text': 'Grid' },
            content: '.grid-view',
            disabled: true
        }
    ],
    loadOn: 'Dynamic'
    
  });
tabObj.appendTo('#element');

var userNameObj = new ej.inputs.TextBox({
    placeholder: 'User Name',
    floatLabelType: 'Auto'
});

userNameObj.appendTo('#username');

let passWordObj = new ej.inputs.TextBox({
    placeholder: 'Password',
    floatLabelType: 'Auto'
});
passWordObj.appendTo('#password');

let buttonObj  = new ej.buttons.Button({
    content: 'Log in',
    isPrimary: true,
});
buttonObj.appendTo('#normalbtn');

let grid = new ej.grids.Grid({
    dataSource: [
        { OrderID: 10248, CustomerID: 'ALFKI', OrderDate: '2024-12-01', Freight: 32.38 },
        { OrderID: 10249, CustomerID: 'ANATR', OrderDate: '2024-12-02', Freight: 11.61 },
        { OrderID: 10250, CustomerID: 'ANTON', OrderDate: '2024-12-03', Freight: 65.83 },
        { OrderID: 10251, CustomerID: 'AROUT', OrderDate: '2024-12-04', Freight: 41.34 }
    ],
    allowPaging: true,
    columns: [
        { field: 'OrderID', headerText: 'Order ID', width: 120, textAlign: 'Right' },
        { field: 'CustomerID', headerText: 'Customer Name', width: 130 },
        { field: 'OrderDate', headerText: 'Order Date', width: 120, format: 'yMd', textAlign: 'Right' },
        { field: 'Freight', headerText: 'Freight', width: 120, format: 'C2', textAlign: 'Right' }
    ]
});
grid.appendTo('#grid')

buttonObj.element.onclick = () => {
    let userName = userNameObj.value;
    let password = passWordObj.value;
    if (!userName && !password) {
        window.alert('Enter both username and password');
    } else if (!userName) {
        window.alert('Enter the username');
    } else if (!password) {
        window.alert('Enter the password');
    } else if (userName.length < 4) {
        window.alert('Username must be at least 4 characters long');
    } else {
        debugger;
        userNameObj.value = "";
        passWordObj.value = "";
        tabObj.items[0].disabled = true;
        tabObj.items[1].disabled = false;
        tabObj.dataBind();
        tabObj.select(1);
    }
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 Tab</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Tab">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/material.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div class="login-form" style="display:none">
            <div class='wrap'>
                <div id="heading">Sign in to view the Grid</div>
                <br>
                <div id="input-container">
                    <input id="username" />
                    <br><br>
                    <input id="password" />
                </div>
            </div>
            <br>
            <div class="button-contain" style="display: flex; justify-content: space-around;">
                <button id="normalbtn"></button>
            </div>
        </div>
        <div class="grid-view" style="display:none">
            <div id=grid></div>
        </div>
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

On initial rendering

This mode can be applied to Tabs by setting the loadOn property to Init. In this mode, the content of all the tabs is rendered on initial load and maintained in the DOM. This mode is ideal when you have a small number of tabs and need to preserve the state of each tab. It also allows you to access the references of components rendered in other tabs.

In the following example, all three tabs are rendered on the initial load, and the data entered in the first tab will be maintained even when the second or third tab is active.

ej.base.enableRipple(true);
var tabObj = new ej.navigations.Tab({
    items: [
        {
            header: { text: 'SignIn' },
            content: '.login-form',
        },
        {
            header: { text: 'Syncfusion EJ2' },
            content: '.over-view',
        },
        {
            header: { text: 'FeedBack' },
            content: '.feed-back',
        }
    ],
    loadOn: 'Init'
    
  });
tabObj.appendTo('#element');

var userNameObj = new ej.inputs.TextBox({
    placeholder: 'Enter Name',
    floatLabelType: 'Auto',
});
userNameObj.appendTo('#username');

var passWordObj = new ej.inputs.TextBox({
    placeholder: 'Enter Password',
    floatLabelType: 'Auto',
});
passWordObj.appendTo('#password');
let signButton = new ej.buttons.Button({
    content: 'Sign in',
    isPrimary: true,
});
signButton.appendTo('#sign-btn');

var skipButton = new ej.buttons.Button({
    content: 'Skip',
    isPrimary: true,
});
skipButton.appendTo('#skip-btn');

var signInName = new ej.inputs.TextBox({
    placeholder: 'Entenr Name',
    floatLabelType: 'Auto'
});
signInName.appendTo('#sign-in-name');

var mail = new ej.inputs.TextBox({
    placeholder: 'Enter Mail',
    floatLabelType: 'Auto',
});
mail.appendTo('#mail');

var comments = new ej.inputs.TextBox({
    placeholder: 'Share your comments',
    floatLabelType: 'Auto',
});
comments.appendTo('#comments');

var submit = new ej.buttons.Button({
    content: 'submit',
    isPrimary: true,
});
submit.appendTo('#submit');

signButton.element.onclick = () => {
    let userName = userNameObj.value;
    let password = passWordObj.value;
    if (signInName) {
        signInName.value = userName
    }
    if (!userName && !password) {
        window.alert('Enter both username and password');
    } else if (!userName) {
        window.alert('Enter the username');
    } else if (!password) {
        window.alert('Enter the password');
    } else if (userName.length < 4) {
        window.alert('Username must be at least 4 characters long');
    }
    tabObj.select(1);
};
skipButton.element.onclick = () => {
    tabObj.select(1);
};
submit.element.onclick = () => {
    userNameObj.value = passWordObj.value = signInName.value = '';
    tabObj.select(0);
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 Tab</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Tab">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/29.2.4/material.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div class="login-form" style="display:none">
            <div class='wrap'>
                <div id="input-container">
                    <input id="username" />
                    <br><br>
                    <input id="password" />
                </div>
            </div>
            <br>
            <div class="button-contain" style="display: flex; justify-content: center; align-items: center; gap:10px;">
                <button id="sign-btn"></button>
                <button id="skip-btn"></button>
            </div>
        </div>
        <div class="over-view" style="display: none;">
            <p>
                You can check out our Syncfusion Ej2 demo
                <a href="https://ej2.syncfusion.com/demos/" target="_blank">here</a>.
            </p>
            <br />
            <p>
                The user guide is available
                <a href="https://ej2.syncfusion.com/documentation/introduction" target="_blank">here</a>.
            </p>
        </div>
        <div class="feed-back" style="display:none">
            <div class='wrap'>
                <div id="input-container">
                    <input id="sign-in-name" />
                    <br><br>
                    <input id="mail" />
                    <br><br>
                    <input id="comments" />
                </div>
            </div>
            <br>
            <div class="button-contain" style="display: flex; justify-content: center; align-items: center; gap:10px;">
                <button id="submit"></button>
            </div>
        </div>
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Content render modes in Angular Tab component

15 Dec 202424 minutes to read

Tabs support rendering content based on different scenarios. The content of the tabs can be rendered in three different ways, as outlined below.

On Demand rendering or lazy loading

This mode is the default, where only the content of the currently selected tab is initially loaded and available in the DOM, with subsequent tab content rendered upon selection. Once a tab’s content is loaded, it remains in the DOM. This ensures that the state of the tabs, such as scroller positions, form values, etc., is preserved.

In the following code example, the Calendar and Scheduler are rendered in the first and second tabs, respectively. Initially, the Scheduler is not available, but it will be rendered once the second tab is selected. Both the Calendar and Scheduler are maintained in the DOM.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule } from '@angular/forms'
import { Component, ViewChild } from '@angular/core';
import { TabModule, TabComponent } from '@syncfusion/ej2-angular-navigations'
import { DayService, ScheduleModule } from '@syncfusion/ej2-angular-schedule';
import { CalendarModule } from '@syncfusion/ej2-angular-calendars';


@Component({
imports: [ FormsModule, TabModule, ScheduleModule, CalendarModule ],
providers: [DayService],
standalone: true,
    selector: 'app-container',
    template: `
<div class="control-section e-tab-section">
    <div class="e-sample-resize-container">
        <!-- Render the Tab Component -->
        <ejs-tab id="tab_default">
            <e-tabitems>
                <e-tabitem [header]="headerText[0]">
                    <ng-template #content>
                        <ejs-calendar></ejs-calendar>
                    </ng-template>
                </e-tabitem>
                <e-tabitem [header]="headerText[1]">
                    <ng-template #content>
                        <ejs-schedule #scheduleObj width="100%" height="650px">
                            <e-views>
                                <e-view option="Day"></e-view>
                            </e-views>
                        </ejs-schedule>
                    </ng-template>
                </e-tabitem>
            </e-tabitems>
        </ejs-tab>
    </div>
</div>
`
})

export class AppComponent {
  public headerText: Object[] = [{ text: "Calendar" },{ text: "Schedule" }];
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

On Demand rendering or lazy loading

This mode can be applied to Tabs by setting the loadOn property to Dynamic using loadOn. In this mode, only the content of the currently selected tab is loaded and available in the DOM initially. When a different tab is selected, its content replaces the current content. Since this mode ensures the DOM maintains only the content of the active tab, page loading performance is improved. However, the Tabs do not retain their state, as each time a tab is selected, it loads its content again.

In the following code example, there are two tabs. The first tab contains a login page, and the second tab contains a Grid component. The Grid component in the second tab will only be rendered in the DOM after the login is completed. Upon successful login, the second tab will replace the first tab in the DOM.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule } from '@angular/forms'
import { Component, ViewChild } from '@angular/core';
import { TabModule, TabComponent } from '@syncfusion/ej2-angular-navigations';
import { TextBoxModule, TextBoxComponent } from '@syncfusion/ej2-angular-inputs';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
import { GridModule } from '@syncfusion/ej2-angular-grids';
/**
 * Adaptive Tab Component
 */

@Component({
imports: [ FormsModule, TabModule, TextBoxModule, ButtonModule, GridModule],
standalone: true,
    selector: 'app-container',
    // specifies the template url path
    template: ` <<div class="control-section e-tab-section">
    <div class="e-sample-resize-container">
        <!-- Render the Tab Component -->
        <ejs-tab #tabObj loadOn="Dynamic">
            <e-tabitems>
                <e-tabitem [header]="headerText[0]" [disabled]="loginDisabled">
                    <ng-template #content>
                    <div class="login-form">
                    <div class="wrap">
                      <div id="heading">Sign in to view the Grid</div>
                      <br />
                      <div id="input-container">
                      <ejs-textbox  #userObj floatLabelType="Auto"  placeholder="Username"></ejs-textbox>
                      <br /><br />
                      <ejs-textbox  #passwordObj floatLabelType="Auto" placeholder="Password"></ejs-textbox>
                      </div>
                    </div>
                    <br />
                    <div class="button-container">
                      <button ejs-button [isPrimary]="true" (click)="handleSubmit()">sign In</button>
                    </div>
                  </div>
                    </ng-template>
                </e-tabitem>
                <e-tabitem [header]="headerText[1]"  [disabled]="gridDisabled">
                    <ng-template #content>
                        <ejs-grid   id='overviewgrid' [dataSource]='gridData'>
                            <e-columns> 
                              <e-column field="OrderID" headerText="Order ID" width="120" ></e-column>
                              <e-column field="CustomerID" headerText="Customer Name" width="130" ></e-column>
                              <e-column field="OrderDate" headerText="Order Date" width="120" format="yMd"></e-column>
                              <e-column field="Freight" headerText="Freight" width="120" format="C2"></e-column>
                            </e-columns>
                          </ejs-grid>
                    </ng-template>
                </e-tabitem>
            </e-tabitems>
        </ejs-tab>
    </div>
</div>`
    })
export class AppComponent {
    @ViewChild('tabObj') public tabObj!: TabComponent;
    @ViewChild('userObj') public userObj!: TextBoxComponent;
    @ViewChild('passwordObj') public passwordObj!: TextBoxComponent;
    public loginDisabled: Boolean = false;
    public gridDisabled: Boolean = true;
    public headerText: Object [] = [{ text: "Login" }, { text: "Grid" }];
    public gridData: object [] = [
        { OrderID: 10248, CustomerID: "ALFKI", OrderDate: "2024-12-01", Freight: 32.38 },
        { OrderID: 10249, CustomerID: "ANATR", OrderDate: "2024-12-02", Freight: 11.61 },
        { OrderID: 10250, CustomerID: "ANTON", OrderDate: "2024-12-03", Freight: 65.83 },
        { OrderID: 10251, CustomerID: "AROUT", OrderDate: "2024-12-04", Freight: 41.34 }
    ];
    public handleSubmit(): void {
        const userName = this.userObj.value;
        const password = this.passwordObj.value;
        if (!userName && !password) {
            window.alert("Enter both username and password");
        } else if (!userName) {
            window.alert("Enter the username");
        } else if (!password) {
            window.alert("Enter the password");
        } else if (userName.length < 4) {
            window.alert("Username must be at least 4 characters long");
        } else {
            this.userObj.value = "";
            this.passwordObj.value = "";
            this.tabObj.items[0].disabled = true;
            this.tabObj.items[1].disabled = false;
            this.tabObj.dataBind();
            this.tabObj.select(1);
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

On initial rendering

This mode can be applied to Tabs by setting the loadOn property to Init using loadOn. In this mode, the content of all the tabs is rendered on initial load and maintained in the DOM. This mode is ideal when you have a small number of tabs and need to preserve the state of each tab. It also allows you to access the references of components rendered in other tabs.

In the following example, all three tabs are rendered on the initial load, and the data entered in the first tab will be maintained even when the second or third tab is active.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule } from '@angular/forms'
import { Component, ViewChild } from '@angular/core';
import { TabModule, TabComponent } from '@syncfusion/ej2-angular-navigations';
import { TextBoxModule, TextBoxComponent } from '@syncfusion/ej2-angular-inputs';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';
/**
 * Adaptive Tab Component
 */

@Component({
imports: [ FormsModule, TabModule, TextBoxModule, ButtonModule],
standalone: true,
    selector: 'app-container',
    // specifies the template url path
    template: ` <div class="control-section e-tab-section">
    <div class="e-sample-resize-container">
        <!-- Render the Tab Component -->
        <ejs-tab #tabObj loadOn="Init" [selectedItem]="selectedItem">
            <e-tabitems>
                <e-tabitem [header]="headerText[0]">
                    <ng-template #content>
                      <div class="login-form">
                        <div class="wrap">
                          <div id="input-container">
                          <ejs-textbox #userObj floatLabelType="Auto" placeholder="Username"></ejs-textbox>
                          <br /><br />
                          <ejs-textbox #passwordObj floatLabelType="Auto"  placeholder="Password"></ejs-textbox>
                          </div>
                        </div>
                        <br />
                        <div class="button-container">
                          <button ejs-button [isPrimary]="true" (click)="handleSignIn()">Sign In</button>
                          <button ejs-button [isPrimary]="true" (click)="handleSkip()">Skip In</button>
                        </div>
                      </div>
                    </ng-template>
                </e-tabitem>
                <e-tabitem [header]="headerText[1]">
                    <ng-template #content>
                      <div class="over-view">
                        <p>
                          You can check out our Syncfusion Ej2 demo
                          <a href="https://ej2.syncfusion.com/demos/" target="_blank" rel="noopener noreferrer">
                            here
                          </a>.
                        </p>
                        <br />
                        <p>
                          The user guide is available
                          <a href="https://ej2.syncfusion.com/documentation/introduction" target="_blank" rel="noopener noreferrer">
                            here
                          </a>.
                        </p>
                    </div>
                    </ng-template>
                </e-tabitem>
                <e-tabitem [header]="headerText[2]">
                  <ng-template #content>
                    <div class="feed-back">
                      <div class="wrap">
                        <div id="input-container">
                        <ejs-textbox floatLabelType="Auto" #nameObj placeholder="User Name"></ejs-textbox>
                          <br /><br />
                          <ejs-textbox  floatLabelType="Auto"  placeholder="Email"></ejs-textbox>
                          <br /><br />
                          <ejs-textbox floatLabelType="Auto" placeholder="Comments"></ejs-textbox>
                        </div>
                      </div>
                      <br />
                      <div class="button-container">
                       <button ejs-button :isPrimary="true" (click)="handleSubmit()">Submit</button>
                      </div>
                    </div>
                  </ng-template>
              </e-tabitem>
            </e-tabitems>
        </ejs-tab>
    </div>
</div>`
    })
export class AppComponent {
    @ViewChild('tabObj')  public tabObj!: TabComponent;
    @ViewChild('userObj')  public userObj!: TextBoxComponent;
    @ViewChild('passwordObj') public passwordObj!: TextBoxComponent;
    @ViewChild('nameObj')  public nameObj!: TextBoxComponent;
    public selectedItem: number = 0;
    public headerText: Object[] = [{ text: "Login" }, { text: "Syncfusion EJ2" }, { text: "FeedBack" }];
    public handleSignIn(): void {
        const userName = this.userObj.value;
        const password = this.passwordObj.value;
        if (!userName && !password) {
            window.alert("Enter both username and password");
        } else if (!userName) {
            window.alert("Enter the username");
        } else if (!password) {
            window.alert("Enter the password");
        } else if (userName.length < 4) {
            window.alert("Username must be at least 4 characters long");
        } else {
            this.selectedItem = 1;
        }
        this.nameObj.value = userName
    }
    public handleSkip = () => {
        this.selectedItem = 1;
    }
    public handleSubmit =  () =>  {
        this.userObj.value = '';
        this.passwordObj.value = '';
        this.nameObj.value  = '';
        this.selectedItem = 0;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Content render modes in React Tab component

13 Dec 202424 minutes to read

Tabs support rendering content based on different scenarios. The content of the tabs can be rendered in three different ways, as outlined below.

On Demand rendering or lazy loading

This mode is the default, where only the content of the currently selected tab is initially loaded and available in the DOM, with subsequent tab content rendered upon selection. Once a tab’s content is loaded, it remains in the DOM. This ensures that the state of the tabs, such as scroller positions, form values, etc., is preserved.

In the following code example, the Calendar and Scheduler are rendered in the first and second tabs, respectively. Initially, the Scheduler is not available, but it will be rendered once the second tab is selected. Both the Calendar and Scheduler are maintained in the DOM.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { useState } from 'react';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';
import { ScheduleComponent, ViewsDirective, ViewDirective, Inject, Day } from '@syncfusion/ej2-react-schedule';
import { CalendarComponent } from '@syncfusion/ej2-react-calendars';

const ReactApp = () => {

  const [headerText] = useState([{ text: "Calendar" }, { text: "Schedule" }]);


  const calendarContent = () => {
    return (
      <div><CalendarComponent></CalendarComponent></div>
    );
  };

  const scheduleContent = () => {
    return (
      <ScheduleComponent width='100%' height='450px'>
        <ViewsDirective>
          <ViewDirective option='Day' />
          <ViewDirective option='Week' />
          <ViewDirective option='WorkWeek' />
          <ViewDirective option='Month' />
        </ViewsDirective>
        <Inject services={[Day]} />
      </ScheduleComponent>
    );
  };


  return (
    <TabComponent>
      <TabItemsDirective>
        <TabItemDirective header={headerText[0]} content={calendarContent} />
        <TabItemDirective header={headerText[1]} content={scheduleContent} />
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { useState } from 'react';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';
import { ScheduleComponent, ViewsDirective, ViewDirective, Inject, Day } from '@syncfusion/ej2-react-schedule';
import { CalendarComponent } from '@syncfusion/ej2-react-calendars';

const ReactApp = () => {

  const [headerText] = useState<[]>([{ text: "Calendar" }, { text: "Schedule" }]);


  const calendarContent = () => {
    return (
      <div><CalendarComponent></CalendarComponent></div>
    );
  };

  const scheduleContent = () => {
    return (
      <ScheduleComponent width='100%' height='450px'>
        <ViewsDirective>
          <ViewDirective option='Day' />
          <ViewDirective option='Week' />
          <ViewDirective option='WorkWeek' />
          <ViewDirective option='Month' />
        </ViewsDirective>
        <Inject services={[Day]} />
      </ScheduleComponent>
    );
  };


  return (
    <TabComponent>
      <TabItemsDirective>
        <TabItemDirective header={headerText[0]} content={calendarContent} />
        <TabItemDirective header={headerText[1]} content={scheduleContent} />
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);

Dynamic rendering

This mode can be applied to Tabs by setting the loadOn property to Dynamic using loadOn. In this mode, only the content of the currently selected tab is loaded and available in the DOM initially. When a different tab is selected, its content replaces the current content. Since this mode ensures the DOM maintains only the content of the active tab, page loading performance is improved. However, the Tabs do not retain their state, as each time a tab is selected, it loads its content again.

In the following code example, there are two tabs. The first tab contains a login page, and the second tab contains a Grid component. The Grid component in the second tab will only be rendered in the DOM after the login is completed. Upon successful login, the second tab will replace the first tab in the DOM.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {useRef, useState} from 'react';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { GridComponent, ColumnsDirective, ColumnDirective, Inject, Page } from '@syncfusion/ej2-react-grids';

const ReactApp = () => {
  
  const tabObj = useRef(null);  
  const userNameObj = useRef(null);
  const passWordObj = useRef(null);
  const [headerText] = useState([{ text: "Login" }, { text: "Grid" }]);
  const [userName, setUserName] = useState('');
  const [password, setPassword] = useState('');
  const [loginDisabled, setLoginDisabled] = useState(false);
  const [gridDisabled, setGridDisabled] = useState(true);

  const handleSubmit = () => {
    const userName = userNameObj.current.value;
    const password = passWordObj.current.value;
    if (!userName && !password) {
      window.alert('Enter both username and password');
    } else if (!userName) {
      window.alert('Enter the username');
    } else if (!password) {
      window.alert('Enter the password');
    } else if (userName.length < 4) {
      window.alert('Username must be at least 4 characters long');
    } else {
      setUserName('');
      setPassword('');
      setLoginDisabled(true);
      setGridDisabled(false);
    }
  };

  const loginContent = () => {
    return (
      <div className="login-form">
        <div className="wrap">
          <div id="heading">Sign in to view the Grid</div>
          <br />
          <div id="input-container">
            <TextBoxComponent placeholder="User Name" value={userName} floatLabelType="Auto" ref={userNameObj} />
            <br /><br />
            <TextBoxComponent placeholder="Password" value={password} floatLabelType="Auto" ref={passWordObj}/>
          </div>
        </div>
        <br />
        <div className="button-contain" style=>
          <ButtonComponent cssClass='e-primary' onClick={handleSubmit}>Submit</ButtonComponent>
        </div>
      </div>
    );
  };

  const gridContent = () => {
    const data = [
      { OrderID: 10248, CustomerID: 'ALFKI', OrderDate: '2024-12-01', Freight: 32.38 },
      { OrderID: 10249, CustomerID: 'ANATR', OrderDate: '2024-12-02', Freight: 11.61 },
      { OrderID: 10250, CustomerID: 'ANTON', OrderDate: '2024-12-03', Freight: 65.83 },
      { OrderID: 10251, CustomerID: 'AROUT', OrderDate: '2024-12-04', Freight: 41.34 }
    ];

    return (
      <GridComponent dataSource={data} allowPaging={true}>
        <ColumnsDirective>
          <ColumnDirective field="OrderID" headerText="Order ID" width="120" />
          <ColumnDirective field="CustomerID" headerText="Customer Name" width="130" />
          <ColumnDirective field="OrderDate" headerText="Order Date" width="120" format="yMd"/>
          <ColumnDirective field="Freight" headerText="Freight" width="120" format="C2"/>
        </ColumnsDirective>
        <Inject services={[Page]} />
      </GridComponent>
    );
  };


  return (
    <TabComponent ref={tabObj} loadOn='Dynamic'>
      <TabItemsDirective>
        <TabItemDirective header={headerText[0]} content={loginContent} disabled={loginDisabled}/>
        <TabItemDirective header={headerText[1]} content={gridContent} disabled={gridDisabled}/>
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {useRef, useState} from 'react';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { GridComponent, ColumnsDirective, ColumnDirective, Inject, Page } from '@syncfusion/ej2-react-grids';

const ReactApp = () => {
  
  const tabObj = useRef<TabComponent>(null);  
  const userNameObj = useRef<TextBoxComponent>(null);
  const passWordObj = useRef<TabComponent>(null);
  const [headerText] = useState<[]>([{ text: "Login" }, { text: "Grid" }]);;
  const [userName, setUserName] = useState<string>('');
  const [password, setPassword] = useState<string>('');
  const [loginDisabled, setLoginDisabled] = useState<Boolean>(false);
  const [gridDisabled, setGridDisabled] = useState<Boolean>(true);

  const handleSubmit = () => {
    const userName: string = userNameObj.current.value;
    const password: string = passWordObj.current.value;
    if (!userName && !password) {
      window.alert('Enter both username and password');
    } else if (!userName) {
      window.alert('Enter the username');
    } else if (!password) {
      window.alert('Enter the password');
    } else if (userName.length < 4) {
      window.alert('Username must be at least 4 characters long');
    } else {
      setUserName('');
      setPassword('');
      setLoginDisabled(true);
      setGridDisabled(false);
    }
  };

  const loginContent = () => {
    return (
      <div className="login-form">
        <div className="wrap">
          <div id="heading">Sign in to view the Grid</div>
          <br />
          <div id="input-container">
            <TextBoxComponent placeholder="User Name" value={userName} floatLabelType="Auto" ref={userNameObj} />
            <br /><br />
            <TextBoxComponent placeholder="Password" value={password} floatLabelType="Auto" ref={passWordObj}/>
          </div>
        </div>
        <br />
        <div className="button-contain" style=>
          <ButtonComponent cssClass='e-primary' onClick={handleSubmit}>Submit</ButtonComponent>
        </div>
      </div>
    );
  };

  const gridContent = () => {
    const data = [
      { OrderID: 10248, CustomerID: 'ALFKI', OrderDate: '2024-12-01', Freight: 32.38 },
      { OrderID: 10249, CustomerID: 'ANATR', OrderDate: '2024-12-02', Freight: 11.61 },
      { OrderID: 10250, CustomerID: 'ANTON', OrderDate: '2024-12-03', Freight: 65.83 },
      { OrderID: 10251, CustomerID: 'AROUT', OrderDate: '2024-12-04', Freight: 41.34 }
    ];

    return (
      <GridComponent dataSource={data} allowPaging={true}>
        <ColumnsDirective>
          <ColumnDirective field="OrderID" headerText="Order ID" width="120" />
          <ColumnDirective field="CustomerID" headerText="Customer Name" width="130" />
          <ColumnDirective field="OrderDate" headerText="Order Date" width="120" format="yMd"/>
          <ColumnDirective field="Freight" headerText="Freight" width="120" format="C2"/>
        </ColumnsDirective>
        <Inject services={[Page]} />
      </GridComponent>
    );
  };


  return (
    <TabComponent ref={tabObj} loadOn='Dynamic'>
      <TabItemsDirective>
        <TabItemDirective header={headerText[0]} content={loginContent} disabled={loginDisabled}/>
        <TabItemDirective header={headerText[1]} content={gridContent} disabled={gridDisabled}/>
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);

On initial rendering

This mode can be applied to Tabs by setting the loadOn property to Init using loadOn. In this mode, the content of all the tabs is rendered on initial load and maintained in the DOM. This mode is ideal when you have a small number of tabs and need to preserve the state of each tab. It also allows you to access the references of components rendered in other tabs.

In the following example, all three tabs are rendered on the initial load, and the data entered in the first tab will be maintained even when the second or third tab is active.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { useRef, useState } from 'react';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

const ReactApp = () => {

  const userNameObj = useRef<TextBoxComponent>(null);
  const passWordObj = useRef<TextBoxComponent>(null);
  const [headerText] = useState([{ text: "Login" }, { text: "Syncfusion EJ2" }, { text: 'FeedBack' }]);;
  const [userName, setUserName] = useState('');
  const [password, setPassword] = useState('');
  const [selectedTabIndex, setSelectedTabIndex] = useState(0);

  const handleSignIn = () => {
    const userName = userNameObj.current.value;
    const password = passWordObj.current.value;
    if (!userName && !password) {
      window.alert('Enter both username and password');
    } else if (!userName) {
      window.alert('Enter the username');
    } else if (!password) {
      window.alert('Enter the password');
    } else if (userName.length < 4) {
      window.alert('Username must be at least 4 characters long');
    }
    setUserName(userName);
    setSelectedTabIndex(1);
  };

  const handleSkip = () => {
    setSelectedTabIndex(1);
  }

  const handleSubmit = () => {
    setUserName('');
    setPassword('');
    setSelectedTabIndex(0);
  }

  const loginContent = () => {
    return (
      <div className="login-form">
        <div className="wrap">
          <div id="input-container">
            <TextBoxComponent placeholder="User Name" value={userName} floatLabelType="Auto" ref={userNameObj} />
            <br /><br />
            <TextBoxComponent placeholder="Password" value={password} floatLabelType="Auto"/>
          </div>
        </div>
        <br />
        <div className="button-contain"
          style=>
          <ButtonComponent cssClass="e-primary" onClick={handleSignIn}> SignIn </ButtonComponent>
          <ButtonComponent cssClass="e-primary" onClick={handleSkip}> Skip </ButtonComponent>
        </div>
      </div>
    );
  };

  const overViewContent = () => {
    return (
      <div className="over-view">
        <p>
          You can check out our Syncfusion Ej2 demo{' '}
          <a href="https://ej2.syncfusion.com/demos/" target="_blank" rel="noopener noreferrer">
            here
          </a>.
        </p>
        <br />
        <p>
          The user guide is available{' '}
          <a href="https://ej2.syncfusion.com/documentation/introduction" target="_blank" rel="noopener noreferrer">
            here
          </a>.
        </p>
      </div>
    );
  }

  const feedBckContent = () => {
    return (
      <div className="feed-back">
        <div className="wrap">
          <div id="input-container">
            <TextBoxComponent placeholder="Name" value={userName} floatLabelType="Auto" />
            <br /><br />
            <TextBoxComponent placeholder="Email" floatLabelType="Auto" />
            <br /><br />
            <TextBoxComponent placeholder="Comment" floatLabelType="Auto" />
          </div>
        </div>
        <br />
        <div
          className="button-contain"
          style=
        >
          <ButtonComponent cssClass="e-primary" onClick={handleSubmit}> submit </ButtonComponent>
        </div>
      </div>
    );
  };


  return (
    <TabComponent loadOn='Init' selectedItem={selectedTabIndex}>
      <TabItemsDirective>
        <TabItemDirective header={headerText[0]} content={loginContent} />
        <TabItemDirective header={headerText[1]} content={overViewContent} />
        <TabItemDirective header={headerText[2]} content={feedBckContent} />
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { useRef, useState } from 'react';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';

const ReactApp = () => {

  const userNameObj = useRef<TextBoxComponent>(null);
  const passWordObj = useRef<TextBoxComponent>(null);
  const [headerText] = useState<[]>([{ text: "Login" }, { text: "Syncfusion EJ2" }, { text: 'FeedBack' }]);;
  const [userName, setUserName] = useState<string>('');
  const [password, setPassword] = useState<string>('');
  const [selectedTabIndex, setSelectedTabIndex] = useState<number>(0);

  const handleSignIn = () => {
    const userName: string = userNameObj.current.value;
    const password: string = passWordObj.current.value;
    if (!userName && !password) {
      window.alert('Enter both username and password');
    } else if (!userName) {
      window.alert('Enter the username');
    } else if (!password) {
      window.alert('Enter the password');
    } else if (userName.length < 4) {
      window.alert('Username must be at least 4 characters long');
    }
    setUserName(userName);
    setSelectedTabIndex(1);
  };

  const handleSkip = () => {
    setSelectedTabIndex(1);
  }

  const handleSubmit = () => {
    setUserName('');
    setPassword('');
    setSelectedTabIndex(0);
  }

  const loginContent = () => {
    return (
      <div className="login-form">
        <div className="wrap">
          <div id="input-container">
            <TextBoxComponent placeholder="User Name" value={userName} floatLabelType="Auto" ref={userNameObj} />
            <br /><br />
            <TextBoxComponent placeholder="Password" value={password} floatLabelType="Auto" ref={passWordObj} />
          </div>
        </div>
        <br />
        <div className="button-contain"
          style=>
          <ButtonComponent cssClass="e-primary" onClick={handleSignIn}> SignIn </ButtonComponent>
          <ButtonComponent cssClass="e-primary" onClick={handleSkip}> Skip </ButtonComponent>
        </div>
      </div>
    );
  };

  const overViewContent = () => {
    return (
      <div className="over-view">
        <p>
          You can check out our Syncfusion Ej2 demo{' '}
          <a href="https://ej2.syncfusion.com/demos/" target="_blank" rel="noopener noreferrer">
            here
          </a>.
        </p>
        <br />
        <p>
          The user guide is available{' '}
          <a href="https://ej2.syncfusion.com/documentation/introduction" target="_blank" rel="noopener noreferrer">
            here
          </a>.
        </p>
      </div>
    );
  }

  const feedBckContent = () => {
    return (
      <div className="feed-back">
        <div className="wrap">
          <div id="input-container">
            <TextBoxComponent placeholder="Name" value={userName} floatLabelType="Auto" />
            <br /><br />
            <TextBoxComponent placeholder="Email" floatLabelType="Auto" />
            <br /><br />
            <TextBoxComponent placeholder="Comment" floatLabelType="Auto" />
          </div>
        </div>
        <br />
        <div
          className="button-contain"
          style=
        >
          <ButtonComponent cssClass="e-primary" onClick={handleSubmit}> submit </ButtonComponent>
        </div>
      </div>
    );
  };


  return (
    <TabComponent loadOn='Init' selectedItem={selectedTabIndex}>
      <TabItemsDirective>
        <TabItemDirective header={headerText[0]} content={loginContent} />
        <TabItemDirective header={headerText[1]} content={overViewContent} />
        <TabItemDirective header={headerText[2]} content={feedBckContent} />
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<ReactApp />);

Content render modes in Vue Tab component

14 Dec 202424 minutes to read

Tabs support rendering content based on different scenarios. The content of the tabs can be rendered in three different ways, as outlined below.

On Demand rendering or lazy loading

This mode is the default, where only the content of the currently selected tab is initially loaded and available in the DOM, with subsequent tab content rendered upon selection. Once a tab’s content is loaded, it remains in the DOM. This ensures that the state of the tabs, such as scroller positions, form values, etc., is preserved.

In the following code example, the Calendar and Scheduler are rendered in the first and second tabs, respectively. Initially, the Scheduler is not available, but it will be rendered once the second tab is selected. Both the Calendar and Scheduler are maintained in the DOM.

<template>
  <div id="app">
    <ejs-tab>
      <e-tabitems>
        <e-tabitem
          :header="headerText0"
          :content="'calendarComponent'"
        ></e-tabitem>
        <template v-slot:calendarComponent>
          <ejs-calendar id="calendar"></ejs-calendar>
        </template>
        <e-tabitem
          :header="headerText1"
          :content="'scheduleComponent'"
        ></e-tabitem>
        <template v-slot:scheduleComponent>
          <ejs-schedule id="Schedule">
            <e-views>
              <e-view option="Day"></e-view>
            </e-views>
          </ejs-schedule>
        </template>
      </e-tabitems>
    </ejs-tab>
  </div>
</template>

<script setup>
import {
  TabComponent as EjsTab,
  TabItemsDirective as ETabitem,
  TabItemDirective as ETabitems,
} from "@syncfusion/ej2-vue-navigations";
import {
  ScheduleComponent as EjsSchedule,
  ViewsDirective as EViews,
  ViewDirective as Eview,
  Day,
} from "@syncfusion/ej2-vue-schedule";
import { CalendarComponent } from "@syncfusion/ej2-vue-calendars";
import { provide } from "vue";

const headerText0 = { text: "Calendar" };
const headerText1 = { text: "Schedule" };
const schedule = [Day];
provide("schedule", schedule);
</script>
<template>
<div id="app">
  <ejs-tab>
    <e-tabitems>
      <e-tabitem :header="headerText0" :content="'calendarComponent'"></e-tabitem>
      <template v-slot:calendarComponent>
      <ejs-calendar id="calendar"></ejs-calendar>
    </template>
      <e-tabitem :header="headerText1" :content="'scheduleComponent'"></e-tabitem>
      <template  v-slot:scheduleComponent>
      <ejs-schedule id="Schedule">
        <e-views>
          <e-view option="Day"></e-view>
        </e-views>
      </ejs-schedule>
    </template>
    </e-tabitems>
  </ejs-tab>
</div>
</template>

<script>
import { TabComponent, TabItemsDirective, TabItemDirective } from "@syncfusion/ej2-vue-navigations";
import { ScheduleComponent, ViewDirective, ViewsDirective, Day} from "@syncfusion/ej2-vue-schedule";
import { CalendarComponent } from "@syncfusion/ej2-vue-calendars";

export default {
name: "App",
components: {
  "ejs-tab": TabComponent,
  "e-tabitem": TabItemDirective,
  "e-tabitems": TabItemsDirective,
  "ejs-schedule": ScheduleComponent,
  "e-view": ViewDirective,
  "e-views": ViewsDirective,
  'ejs-calendar': CalendarComponent,
},
data: function () {
  return {
    headerText0: { text: "Calendar" },
    headerText1: { text: "Schedule" },
  };
},
provide: {
  schedule: [Day],
},
};
</script>

Dynamic rendering

This mode can be applied to Tabs by setting the loadOn property to Dynamic using loadOn. In this mode, only the content of the currently selected tab is loaded and available in the DOM initially. When a different tab is selected, its content replaces the current content. Since this mode ensures the DOM maintains only the content of the active tab, page loading performance is improved. However, the Tabs do not retain their state, as each time a tab is selected, it loads its content again.

In the following code example, there are two tabs. The first tab contains a login page, and the second tab contains a Grid component. The Grid component in the second tab will only be rendered in the DOM after the login is completed. Upon successful login, the second tab will replace the first tab in the DOM.

<template>
<div id="app">
  <ejs-tab loadOn='Dynamic'>
    <e-tabitems>
      <e-tabitem :header="headerText0" :content="'loginForm'" :disabled="loginDisabled"></e-tabitem>
      <template v-slot:loginForm>
          <div class="login-form">
            <div class="wrap">
              <div id="heading">Sign in to view the Grid</div>
              <br />
              <div id="input-container">
              <ejs-textbox ref="userObj" floatLabelType="Auto" :value="userName" placeholder="Username"></ejs-textbox>
              <br /><br />
              <ejs-textbox ref="passwordObj" floatLabelType="Auto" :value="passWord" placeholder="Password"></ejs-textbox>
              </div>
            </div>
            <br />
            <div class="button-container">
              <ejs-button :isPrimary="true" v-on:click="handleSubmit">Sign In</ejs-button>
            </div>
          </div>
      </template>

      <e-tabitem :header="headerText1" :content="'grid'" :disabled="gridDisabled"></e-tabitem>
        <template v-slot:grid>
          <ejs-grid ref="overviewGrid" :dataSource="gridData">
            <e-columns> 
              <e-column field="OrderID" headerText="Order ID" width="120" ></e-column>
              <e-column field="CustomerID" headerText="Customer Name" width="130" ></e-column>
              <e-column field="OrderDate" headerText="Order Date" width="120" format="yMd"></e-column>
              <e-column field="Freight" headerText="Freight" width="120" format="C2"></e-column>
            </e-columns>
          </ejs-grid>
        </template>
    </e-tabitems>
  </ejs-tab>
</div>
</template>
<script setup>
import { TabComponent as EjsTab, TabItemsDirective as ETabitem, TabItemDirective as ETabitems } from "@syncfusion/ej2-vue-navigations";
import { TextBoxComponent as EjsTextbox  } from "@syncfusion/ej2-vue-inputs";
import { ButtonComponent as EjsButton  } from "@syncfusion/ej2-vue-buttons";
import { GridComponent as EjsGrid, ColumnsDirective as EColumns, ColumnDirective as EColumn} from "@syncfusion/ej2-vue-grids";
import { ref } from "vue";

const userObj = ref(null);
const passwordObj = ref(null);

const headerText0 = { text: "Login" };
const headerText1 = { text: "Grid" };
const loginDisabled = false;
const gridDisabled =  true;
const userName = "";
const passWord = "";
const gridData = [
        { OrderID: 10248, CustomerID: "ALFKI", OrderDate: "2024-12-01", Freight: 32.38 },
        { OrderID: 10249, CustomerID: "ANATR", OrderDate: "2024-12-02", Freight: 11.61 },
        { OrderID: 10250, CustomerID: "ANTON", OrderDate: "2024-12-03", Freight: 65.83 },
        { OrderID: 10251, CustomerID: "AROUT", OrderDate: "2024-12-04", Freight: 41.34 } ]

const handleSubmit = () => {
      const userName = userObj.value.$el.ej2_instances[0].value;
      const password = passwordObj.value.$el.ej2_instances[0].value;
      if (!userName && !password) {
        window.alert("Enter both username and password");
      } else if (!userName) {
        window.alert("Enter the username");
      } else if (!password) {
        window.alert("Enter the password");
      } else if (userName.length < 4) {
        window.alert("Username must be at least 4 characters long");
      } else {
        userObj.value.$el.ej2_instances[0].value = "";
        passwordObj.value.$el.ej2_instances[0].value = "";
        this.loginDisabled = true;
        this.gridDisabled = false
      }
}
</script>

<style>
   .button-container {
      display: flex;
      justify-content: center;
   }
</style>
<template>
<div id="app">
  <ejs-tab loadOn='Dynamic'>
    <e-tabitems>
      <e-tabitem :header="headerText0" :content="'loginForm'" :disabled="loginDisabled"></e-tabitem>
      <template v-slot:loginForm>
          <div class="login-form">
            <div class="wrap">
              <div id="heading">Sign in to view the Grid</div>
              <br />
              <div id="input-container">
              <ejs-textbox ref="userObj" floatLabelType="Auto" :value="userName" placeholder="Username"></ejs-textbox>
              <br /><br />
              <ejs-textbox ref="passwordObj" floatLabelType="Auto" :value="passWord" placeholder="Password"></ejs-textbox>
              </div>
            </div>
            <br />
            <div class="button-container">
              <ejs-button :isPrimary="true" @click="handleSubmit">Sign In</ejs-button>
            </div>
          </div>
      </template>

      <e-tabitem :header="headerText1" :content="'grid'" :disabled="gridDisabled"></e-tabitem>
        <template v-slot:grid>
          <ejs-grid ref="overviewGrid" :dataSource="gridData">
            <e-columns> 
              <e-column field="OrderID" headerText="Order ID" width="120" ></e-column>
              <e-column field="CustomerID" headerText="Customer Name" width="130" ></e-column>
              <e-column field="OrderDate" headerText="Order Date" width="120" format="yMd"></e-column>
              <e-column field="Freight" headerText="Freight" width="120" format="C2"></e-column>
            </e-columns>
          </ejs-grid>
        </template>
    </e-tabitems>
  </ejs-tab>
</div>
</template>
<script>
import { TabComponent, TabItemsDirective, TabItemDirective } from "@syncfusion/ej2-vue-navigations";
import { TextBoxComponent } from "@syncfusion/ej2-vue-inputs";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
import { GridComponent, ColumnsDirective, ColumnDirective } from "@syncfusion/ej2-vue-grids";

export default {
name: "App",
components: {
  "ejs-tab": TabComponent,
  "e-tabitem": TabItemDirective,
  "e-tabitems": TabItemsDirective,
  "ejs-textbox": TextBoxComponent,
  "ejs-button": ButtonComponent,
  "ejs-grid": GridComponent,
  "e-columns": ColumnsDirective,
  "e-column": ColumnDirective,
},
data: function () {
  return {
    headerText0: { text: "Login" },
    headerText1: { text: "Grid" },
    loginDisabled: false,
    gridDisabled: true,
    userName: "",
    passWord: "",
    gridData: [
      { OrderID: 10248, CustomerID: "ALFKI", OrderDate: "2024-12-01", Freight: 32.38 },
      { OrderID: 10249, CustomerID: "ANATR", OrderDate: "2024-12-02", Freight: 11.61 },
      { OrderID: 10250, CustomerID: "ANTON", OrderDate: "2024-12-03", Freight: 65.83 },
      { OrderID: 10251, CustomerID: "AROUT", OrderDate: "2024-12-04", Freight: 41.34 } ]
  };
},
methods: {
    handleSubmit() {
      const userName = this.$refs.userObj.ej2Instances.value;
      const password = this.$refs.passwordObj.ej2Instances.value;
      if (!userName && !password) {
        window.alert("Enter both username and password");
      } else if (!userName) {
        window.alert("Enter the username");
      } else if (!password) {
        window.alert("Enter the password");
      } else if (userName.length < 4) {
        window.alert("Username must be at least 4 characters long");
      } else {
        this.$refs.userObj.ej2Instances.value = "";
        this.$refs.passwordObj.ej2Instances.value = "";
        this.loginDisabled = true;
        this.gridDisabled = false
      }
    },
}
};
</script>

<style>
   .button-container {
      display: flex;
      justify-content: center;
   }
</style>

On initial rendering

This mode can be applied to Tabs by setting the loadOn property to Init using loadOn. In this mode, the content of all the tabs is rendered on initial load and maintained in the DOM. This mode is ideal when you have a small number of tabs and need to preserve the state of each tab. It also allows you to access the references of components rendered in other tabs.

In the following example, all three tabs are rendered on the initial load, and the data entered in the first tab will be maintained even when the second or third tab is active.

<template>
<div id="app">
  <ejs-tab :selectedItem="selectedItem" loadOn="Init">
    <e-tabitems>
      <e-tabitem :header="headerText0" :content="'loginForm'"></e-tabitem>
      <template v-slot:loginForm>
          <div class="login-form">
            <div class="wrap">
              <div id="input-container">
              <ejs-textbox ref="userObj" floatLabelType="Auto" :value="userName" placeholder="Username"></ejs-textbox>
              <br /><br />
              <ejs-textbox ref="passwordObj" floatLabelType="Auto" :value="passWord" placeholder="Password"></ejs-textbox>
              </div>
            </div>
            <br />
            <div class="button-container">
              <ejs-button :isPrimary="true" v-on:click="handleSignIn">Sign In</ejs-button>
              <ejs-button :isPrimary="true" v-on:click="handleSkip">Skip In</ejs-button>
            </div>
          </div>
      </template>

      <e-tabitem :header="headerText1" :content="'overView'" ></e-tabitem>
        <template v-slot:overView>
        <div class="over-view">
          <p>
            You can check out our Syncfusion Ej2 demo
            <a href="https://ej2.syncfusion.com/demos/" target="_blank" rel="noopener noreferrer">
              here
            </a>.
          </p>
          <br />
          <p>
            The user guide is available
            <a href="https://ej2.syncfusion.com/documentation/introduction" target="_blank" rel="noopener noreferrer">
              here
            </a>.
          </p>
      </div>
        </template>
        <e-tabitem :header="headerText2" :content="'feedBack'" ></e-tabitem>
        <template v-slot:feedBack>
          <div class="feed-back">
          <div class="wrap">
            <div id="input-container">
            <ejs-textbox floatLabelType="Auto" ref="nameObj" :value="userName" placeholder="Name"></ejs-textbox>
              <br /><br />
              <ejs-textbox  floatLabelType="Auto"  placeholder="Email"></ejs-textbox>
              <br /><br />
              <ejs-textbox floatLabelType="Auto" placeholder="Comments"></ejs-textbox>
            </div>
          </div>
          <br />
          <div class="button-container">
           <ejs-button :isPrimary="true" v-on:click="handleSubmit">Submit</ejs-button>
          </div>
        </div>
        </template>
    </e-tabitems>

  </ejs-tab>
</div>
</template>

<script setup>
import { TabComponent as EjsTab, TabItemsDirective as ETabitem, TabItemDirective as ETabitems } from "@syncfusion/ej2-vue-navigations";
import { TextBoxComponent as EjsTextbox  } from "@syncfusion/ej2-vue-inputs";
import { ButtonComponent as EjsButton  } from "@syncfusion/ej2-vue-buttons";

import { ref } from "vue";

const userObj = ref(null);
const passwordObj = ref(null);
const nameObj = ref(null);

const headerText0 = { text: "Login" };
const headerText1 = { text: "Syncfusion EJ2" };
const headerText2 = { text: "FeedBack" };
const userName = "";
const passWord = "";
let selectedItem = 0;


const handleSignIn = () => {
    const userName = userObj.value.$el.ej2_instances[0].value;
    const password = passwordObj.value.$el.ej2_instances[0].value;
    if (!userName && !password) {
      window.alert("Enter both username and password");
    } else if (!userName) {
      window.alert("Enter the username");
    } else if (!password) {
      window.alert("Enter the password");
    } else if (userName.length < 4) {
      window.alert("Username must be at least 4 characters long");
    }
    nameObj.value$el.ej2_instances[0].value = userName;
    this.selectedItem = 1;
}

const handleSkip = () => {
    this.selectedItem = 1;
}

const handleSubmit =  () =>  {
    userObj.value.$el.ej2_instances[0].value = '';
    passwordObj.value.$el.ej2_instances[0].value = ''
    this.selectedItem = 0;
}
</script>

<style>
.button-container {
    display: flex;
    justify-content: center;
    align-items: center; 
    gap: 10px;
}
</style>
<template>
<div id="app">
  <ejs-tab :selectedItem="selectedItem" loadOn="Init">
    <e-tabitems>
      <e-tabitem :header="headerText0" :content="'loginForm'"></e-tabitem>
      <template v-slot:loginForm>
          <div class="login-form">
            <div class="wrap">
              <div id="input-container">
              <ejs-textbox ref="userObj" floatLabelType="Auto" :value="userName" placeholder="Username"></ejs-textbox>
              <br /><br />
              <ejs-textbox ref="passwordObj" floatLabelType="Auto" :value="passWord" placeholder="Password"></ejs-textbox>
              </div>
            </div>
            <br />
            <div class="button-container">
              <ejs-button :isPrimary="true" v-on:click="handleSignIn">Sign In</ejs-button>
              <ejs-button :isPrimary="true" v-on:click="handleSkip">Skip In</ejs-button>
            </div>
          </div>
      </template>

      <e-tabitem :header="headerText1" :content="'overView'" ></e-tabitem>
        <template v-slot:overView>
        <div class="over-view">
          <p>
            You can check out our Syncfusion Ej2 demo
            <a href="https://ej2.syncfusion.com/demos/" target="_blank" rel="noopener noreferrer">
              here
            </a>.
          </p>
          <br />
          <p>
            The user guide is available
            <a href="https://ej2.syncfusion.com/documentation/introduction" target="_blank" rel="noopener noreferrer">
              here
            </a>.
          </p>
      </div>
        </template>
        <e-tabitem :header="headerText2" :content="'feedBack'" ></e-tabitem>
        <template v-slot:feedBack>
          <div class="feed-back">
          <div class="wrap">
            <div id="input-container">
            <ejs-textbox floatLabelType="Auto" ref="nameObj" :value="userName" placeholder="Name"></ejs-textbox>
              <br /><br />
              <ejs-textbox  floatLabelType="Auto"  placeholder="Email"></ejs-textbox>
              <br /><br />
              <ejs-textbox floatLabelType="Auto" placeholder="Comments"></ejs-textbox>
            </div>
          </div>
          <br />
          <div class="button-container">
           <ejs-button :isPrimary="true" v-on:click="handleSubmit">Submit</ejs-button>
          </div>
        </div>
        </template>
    </e-tabitems>

  </ejs-tab>
</div>
</template>
<script>
import { TabComponent, TabItemsDirective, TabItemDirective } from "@syncfusion/ej2-vue-navigations";
import { TextBoxComponent } from "@syncfusion/ej2-vue-inputs";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";

export default {
name: "App",
components: {
  "ejs-tab": TabComponent,
  "e-tabitem": TabItemDirective,
  "e-tabitems": TabItemsDirective,
  "ejs-textbox": TextBoxComponent,
  "ejs-button": ButtonComponent
},
data: function () {
  return {
    headerText0: { text: "Login" },
    headerText1: { text: "Syncfusion EJ2" },
    headerText2: { text: "FeedBack" },
    userName: "",
    passWord: "",
    selectedItem: 0
  };
},
methods: {
    handleSignIn() {
      const userName = this.$refs.userObj.ej2Instances.value;
      const password = this.$refs.passwordObj.ej2Instances.value;
      if (!userName && !password) {
        window.alert("Enter both username and password");
      } else if (!userName) {
        window.alert("Enter the username");
      } else if (!password) {
        window.alert("Enter the password");
      } else if (userName.length < 4) {
        window.alert("Username must be at least 4 characters long");
      }
      this.$refs.nameObj.ej2Instances.value = userName;
      this.selectedItem = 1;
    },
    handleSkip() {
        this.selectedItem = 1;
    },
    handleSubmit () {
        this.$refs.userObj.ej2Instances.value = '';
        this.$refs.passwordObj.ej2Instances.value = ''
        this.selectedItem = 0;
    }
},
};
</script>
<style>
.button-container {
    display: flex;
    justify-content: center;
    align-items: center; 
    gap: 10px;
}
</style>